<?php

namespace Modules\Order\Requests\Web;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\Product\Models\Product;
use Modules\Product\Models\ProductAttribute;
use Modules\User\Enums\AccountStatusEnum;
use Modules\User\Services\AccountService;

class CartRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules =
            [
                'product_id'=>[
                    'required',
                    'exists:products,id'
                ],
                'count'=>'required|numeric',
            ];
        $product = Product::find(request('product_id'));
        if($product)
        {
            if(count($product->sizes))
            {
                if(request('color_id'))
                {
                    $attribute = ProductAttribute::find(request('color_id'));
                    $rules['count'] =  'required|numeric|lte:'.$attribute->count;
                }
                else
                {
                    $rules['size_id'] = 'required';
                    $rules['color_id'] = 'required';
                }
            }
            else
            {
                if ($product->count > request('count'))
                {
                    $rules['count'] = 'required|numeric|lte:'.$product->count;
                }
            }
        }
        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [
            'product_id' => __('web.product_id'),
            'count' => __('web.count'),
            'size_id' => __('web.size'),
            'color_id' => __('web.color'),
        ];
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
